<?php

defined('_VALID_CALL') or die('Direct Access is not allowed.');

$sRootPath = dirname(dirname(dirname(dirname(__FILE__))));
require_once($sRootPath . '/idealcheckout/includes/library.php');

class xt_idealcheckoutmaestro
{
	public $external = true;
	public $subpayments = false;
	public $iframe = false;
	public $data = array();

	public $TARGET_URL;
	public $TARGET_PARAMS = array();

	function pspRedirect($aOrderData)
	{
		global $xtLink, $filter, $order, $db;

		// Add transaction record to database
		$aDatabaseSettings = idealcheckout_getDatabaseSettings();

		$sStoreCode = idealcheckout_getStoreCode();
		$sGatewayCode = 'maestro';
		$sLanguageCode = 'nl'; // strtolower(substr($order->order_data['language_code'], 0, 2));
		$sCountryCode = ''; // strtolower(substr($order->order_data['billing_country_code'], 0, 2));
		$sCurrencyCode = 'EUR'; // strtoupper($order->order_data['currency_code']);

		$sOrderId = $order->oID;
		$sOrderCode = idealcheckout_getRandomCode(32);
		$aOrderParams = array();
		$sTransactionId = idealcheckout_getRandomCode(32);
		$sTransactionCode = idealcheckout_getRandomCode(32);
		$fTransactionAmount = round($order->order_total['total']['plain'], 2);
		$sTransactionDescription = idealcheckout_getTranslation($sLanguageCode, 'idealcheckout', 'Webshop order #{0}', array($sOrderId));

		$sTransactionPaymentUrl = $xtLink->_link(array('page' => 'checkout', 'paction' => 'payment', 'conn' => 'SSL'));
		$sTransactionSuccessUrl = $xtLink->_link(array('page' => 'callback', 'paction' => 'xt_idealcheckoutmaestro', 'conn' => 'SSL'));
		$sTransactionSuccessUrl .= (strpos($sTransactionSuccessUrl, '?') ? '&' : '?') . 'order_id=' . $sOrderId . '&order_code=' . $sOrderCode;
		$sTransactionPendingUrl = $sTransactionSuccessUrl;
		$sTransactionFailureUrl = $sTransactionPaymentUrl;

		// Store order data
		$aOrderParams['order_data'] = $order->order_data;



		// Insert into #_transactions
		$sql = "INSERT INTO `" . $aDatabaseSettings['table'] . "` SET 
`id` = NULL, 
`order_id` = '" . idealcheckout_escapeSql($sOrderId) . "', 
`order_code` = '" . idealcheckout_escapeSql($sOrderCode) . "', 
`order_params` = '" . idealcheckout_escapeSql(idealcheckout_serialize($aOrderParams)) . "', 
`store_code` = " . (empty($sStoreCode) ? "NULL" : "'" . idealcheckout_escapeSql($sStoreCode) . "'") . ", 
`gateway_code` = '" . idealcheckout_escapeSql($sGatewayCode) . "', 
`language_code` = " . (empty($sLanguageCode) ? "NULL" : "'" . idealcheckout_escapeSql($sLanguageCode) . "'") . ", 
`country_code` = " . (empty($sCountryCode) ? "NULL" : "'" . idealcheckout_escapeSql($sCountryCode) . "'") . ", 
`currency_code` = '" . idealcheckout_escapeSql($sCurrencyCode) . "', 
`transaction_id` = '" . idealcheckout_escapeSql($sTransactionId) . "', 
`transaction_code` = '" . idealcheckout_escapeSql($sTransactionCode) . "', 
`transaction_params` = NULL, 
`transaction_date` = '" . idealcheckout_escapeSql(time()) . "', 
`transaction_amount` = '" . idealcheckout_escapeSql($fTransactionAmount) . "', 
`transaction_description` = '" . idealcheckout_escapeSql($sTransactionDescription) . "', 
`transaction_status` = NULL, 
`transaction_url` = NULL, 
`transaction_payment_url` = '" . idealcheckout_escapeSql($sTransactionPaymentUrl) . "', 
`transaction_success_url` = '" . idealcheckout_escapeSql($sTransactionSuccessUrl) . "', 
`transaction_pending_url` = '" . idealcheckout_escapeSql($sTransactionPendingUrl) . "', 
`transaction_failure_url` = '" . idealcheckout_escapeSql($sTransactionFailureUrl) . "', 
`transaction_log` = NULL;";

		$db->Execute($sql);


		$oOrder = new order($_SESSION['last_order_id'], $_SESSION['customer']->customers_id);
		$oOrder->_sendOrderMail($_SESSION['last_order_id']);


		// Redirect to checkout
		$sRedirectUrl = idealcheckout_getRootUrl() . 'idealcheckout/setup.php?order_id=' . $sOrderId . '&order_code=' . $sOrderCode;

		return $sRedirectUrl;
	}

	function debug($s, $txt = null)
	{
		return;
	} 

	function pspSuccess()
	{
		return true;
	}
}

?>